<?php

namespace SM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use SM\Service\HabilidadePessoalService;
use SM\Traits\TResponse;

class HabilidadePessoalController
{
    use TResponse;
    protected $habilidadePessoalService;

    public function __construct(HabilidadePessoalService $habilidadePessoalService)
    {
        $this->habilidadePessoalService = $habilidadePessoalService;
    }

    public function getHabilidadePessoal()
    {
        try {
            $data = $this->habilidadePessoalService->getHabilidadePessoal();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function adicionarHabilidadePessoal(Request $request)
    {
        try {
            $data = $this->habilidadePessoalService->adicionarHabilidadePessoal($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteHabilidadePessoal(DTO\Request $request)
    {
        try {
            $this->habilidadePessoalService->deleteHabilidadePessoal($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveTabHabilidadePessoal(DTO\Request $request)
    {
        try {
            $this->habilidadePessoalService->saveTabHabilidadePessoal($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getHabPessoalTabPessoas(DTO\Request $request)
    {
        try {
            $data = $this->habilidadePessoalService->getHabPessoalTabPessoas($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getHabPessoalPessoas()
    {
        try {
            $data = $this->habilidadePessoalService->getHabPessoalPessoas();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveModalAddPessoa(DTO\Request $request)
    {
        try {
            $this->habilidadePessoalService->saveModalAddPessoa($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deletePessoas(DTO\Request $request)
    {
        try {
            $this->habilidadePessoalService->deletePessoas($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

}