<?php

namespace SM\Controller;

use SM\Controller\SMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use SM\Service\Sm00034001DescontoPeriodoCarenciaOperadorService;
use SM\Traits\TResponse;

class Sm00034001DescontoPeriodoCarenciaOperadorController extends SMCrud
{

    use TResponse;

    protected $descontoPeriodoOperadorService;

    public function __construct($crudService, $environment, Sm00034001DescontoPeriodoCarenciaOperadorService $descontoPeriodoOperadorService)
    {
        parent::__construct($crudService, $environment);
        $this->descontoPeriodoOperadorService = $descontoPeriodoOperadorService;
    }

    public function getDescontoPeriodoCarenciaOperador()
    {
        try {
            $data = $this->descontoPeriodoOperadorService->getDescontoPeriodoCarenciaOperador();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function getIdBloq()
    {
        try {
            $data = $this->descontoPeriodoOperadorService->getIdBloq();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function botaoAtivar(DTO\Request $request)
    {
        try {
            $this->descontoPeriodoOperadorService->botaoAtivar($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function inserirDescontoPeriodoCarenciaOperador(DTO\Request $request)
    {
        try {
            $this->descontoPeriodoOperadorService->inserirDescontoPeriodoCarenciaOperador($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deletarDescontoPeriodoCarenciaOperador(DTO\Request $request)
    {
        try {
            $this->descontoPeriodoOperadorService->deletarDescontoPeriodoCarenciaOperador($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
