/*
TECNISA - TECNOLOGIA EM INFORMTICA

NOME: INSERE_FORMULARIONF

DESCRIO:
   PROCEDIMENTO PARA INSERIR OS FORMULARIOS PENDENTES NA TABELA FORMULARIONF.

@C:\WEB_407\SQL\End_Conv\ORACLE\5053_DFSSTPO.SQL
*/

CREATE OR REPLACE PROCEDURE INSERE_FORMULARIONF (
      P_CDCTRLNUMENF IN CTRLNUMENF.CDCTRLNUMENF%TYPE,
      P_NRCTRLFORMNF IN CTRLFORMNF.NRCTRLFORMNF%TYPE,
      P_NRNUMEINI    IN CTRLFORMNF.NRNUMEINIFRM%TYPE,
      P_NRNUMEFIN    IN CTRLFORMNF.NRNUMEFINFRM%TYPE,
      P_CDFILIAL     IN FILIAL.CDFILIAL%TYPE)
IS

   V_CDCTRLNUMENF CTRLNUMENF.CDCTRLNUMENF%TYPE;
   V_NRCTRLFORMNF CTRLFORMNF.NRCTRLFORMNF%TYPE;
   V_NRFORMULARNF FORMULARIONF.NRFORMULARNF%TYPE;
   V_IDSTATUSFORM FORMULARIONF.IDSTATUSFORM%TYPE;
   V_NRNUMEINIFRM NUMBER;
   V_NRNUMEFINFRM NUMBER;
   V_NRTAMNUMNFUT PARAMFILIAL.NRTAMNUMNFUT%TYPE;

BEGIN

   SELECT MAX(CDCTRLNUMENF), MAX(NRCTRLFORMNF), MAX(NRFORMULARNF), MAX(IDSTATUSFORM)
   INTO V_CDCTRLNUMENF, V_NRCTRLFORMNF, V_NRFORMULARNF, V_IDSTATUSFORM
   FROM FORMULARIONF
   WHERE (CDCTRLNUMENF = P_CDCTRLNUMENF) AND
         (NRCTRLFORMNF = P_NRCTRLFORMNF);

   IF NOT(V_CDCTRLNUMENF IS NULL) THEN
      DELETE FROM FORMULARIONF
      WHERE (CDCTRLNUMENF = P_CDCTRLNUMENF) AND
            (NRCTRLFORMNF = P_NRCTRLFORMNF);
   END IF;

   V_NRNUMEINIFRM := TO_NUMBER(P_NRNUMEINI);
   V_NRNUMEFINFRM := TO_NUMBER(P_NRNUMEFIN);

   SELECT NVL(MAX(NRTAMNUMNFUT), 7)
   INTO V_NRTAMNUMNFUT
   FROM PARAMFILIAL
   WHERE CDFILIAL = P_CDFILIAL;

   IF (V_NRTAMNUMNFUT IS NULL) THEN
      V_NRTAMNUMNFUT := 7;
   END IF;

   WHILE (V_NRNUMEINIFRM <= V_NRNUMEFINFRM) LOOP
      INSERT INTO FORMULARIONF
         (CDCTRLNUMENF, NRCTRLFORMNF, NRFORMULARNF, IDSTATUSFORM)
      VALUES
         (P_CDCTRLNUMENF, P_NRCTRLFORMNF, LPAD(TO_CHAR(V_NRNUMEINIFRM), V_NRTAMNUMNFUT,'0'), 'P');

      V_NRNUMEINIFRM := V_NRNUMEINIFRM + 1;
   END LOOP;

END;
/



-- VERSAO --
BEGIN ATUVEROBJ('INSERE_FORMULARIONF','5.07.011'); END;
/

