import { Utilities } from '@/util/Utilities';
import { Metadata } from '@zeedhi/core';
import { TekGrid } from '@zeedhi/teknisa-components-common';
import {
    Form, Modal, ModalService, Text,
} from '@zeedhi/common';

export class EquipeTrabalhoController {
    private visibilidadeFrameAgendamentoRecurso: boolean = true;

    private currentRowRecurso : any = {};

    private modal!: Modal;

    public async abrirModalAddRecursoEquipeTrabalho() {
        this.modal = await ModalService.createFromJson('agendamentoRecursos/modal/modalAddRecursoEquipeTrabalho', true);
        this.modal.show();
    }

    public async abrirModalEditRecursoEquipeTrabalho() {
        this.modal = await ModalService.createFromJson('agendamentoRecursos/modal/modalAddRecursoEquipeTrabalho', true);
        this.modal.show();
    }

    public fecharModalAddRecursoEquipeTrabalho() {
        this.modal.hide();
        this.modal?.destroy();
    }

    get visibilidadeFrameEquipeTrabalho() {
        return !this.visibilidadeFrameAgendamentoRecurso;
    }

    public voltarGridEquipeTrabalho() {
        this.visibilidadeFrameAgendamentoRecurso = true;
    }

    public abrirFrameEquipeTrabalho({ row }: any) {
        this.visibilidadeFrameAgendamentoRecurso = false;
        this.currentRowRecurso = row;
    }

    public get getvisibilidadeFrameAgendamentoRecurso() {
        if (this.visibilidadeFrameAgendamentoRecurso) {
            this.setDisplayFlex('container-frame-agendamento-recursos');
        }
        return this.visibilidadeFrameAgendamentoRecurso;
    }

    public setDisplayFlex(componentName: string) {
        setTimeout(() => {
            const a = document.getElementById(componentName) as any;
            a.style.display = 'flex';
        }, 0);
    }

    public get getTituloNrFctContrato() {
        return Metadata.getInstance<Text>('title-frame-agendamento-recursos').text;
    }

    public get getTituloFrameEquipeTrabalho() {
        return `${this.getTituloNrFctContrato} >> ${this.currentRowRecurso.NMITEMCONTRATO}`;
    }

    public get nrseqcontratoAgendRecurso() {
        return Metadata.getInstance<TekGrid>('grid-agendamento-recursos').datasource.currentRow.NRSEQCONTRATO;
    }

    public setFilterCampoItemContrato({ component }: any) {
        const nrseqcontrato = this.nrseqcontratoAgendRecurso;
        try {
            component.datasource.setFilter({
                NRSEQCONTRATO: nrseqcontrato,
            });
        } catch (e) {
            Utilities.showErrorMessage(e);
        }
    }

    public setFilterCampoRecurso({ component }: any) {
        console.warn(component);
    }

    public expandir({ component }: any) {
        const form = Metadata.getInstance<Form>(component.name.split('_')[1]);
        form.isVisible = !form.isVisible;
        component.iconName = (component.iconName === 'mdi-chevron-down') ? 'mdi-chevron-right' : 'mdi-chevron-down';
    }
}
